From 73b7264eb0cea5e3ba2b30674e49d478cd00cb0a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 26 2020 01:44:10 +0000
Subject: [PATCH 1557/2232] Generalize Type::SliceRefU8 to Type::SliceRef


---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index d9e20da..0757146 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -167,7 +167,7 @@ fn pick_includes_and_builtins(out: &mut OutFile, apis: &[Api]) {
             Type::Str(_) => out.builtin.rust_str = true,
             Type::CxxVector(_) => out.include.vector = true,
             Type::Fn(_) => out.builtin.rust_fn = true,
-            Type::SliceRefU8(_) => {
+            Type::SliceRef(_) => {
                 out.include.cstdint = true;
                 out.builtin.rust_slice = true;
             }
@@ -435,7 +435,7 @@ fn write_cxx_function_shim<'a>(out: &mut OutFile<'a>, efn: &'a ExternFn) {
             out.builtin.rust_str_repr = true;
             write!(out, "::rust::impl<::rust::Str>::repr(");
         }
-        Some(ty @ Type::SliceRefU8(_)) if !indirect_return => {
+        Some(ty @ Type::SliceRef(_)) if !indirect_return => {
             out.builtin.rust_slice_repr = true;
             write!(out, "::rust::impl<");
             write_type(out, ty);
@@ -475,7 +475,7 @@ fn write_cxx_function_shim<'a>(out: &mut OutFile<'a>, efn: &'a ExternFn) {
             out.builtin.unsafe_bitcopy = true;
             write_type(out, &arg.ty);
             write!(out, "(::rust::unsafe_bitcopy, *{})", arg.ident);
-        } else if let Type::SliceRefU8(slice) = &arg.ty {
+        } else if let Type::SliceRef(slice) = &arg.ty {
             write_type(out, &arg.ty);
             write!(out, "(static_cast<");
             if slice.mutability.is_none() {
@@ -493,7 +493,7 @@ fn write_cxx_function_shim<'a>(out: &mut OutFile<'a>, efn: &'a ExternFn) {
     match &efn.ret {
         Some(Type::RustBox(_)) => write!(out, ".into_raw()"),
         Some(Type::UniquePtr(_)) => write!(out, ".release()"),
-        Some(Type::Str(_)) | Some(Type::SliceRefU8(_)) if !indirect_return => write!(out, ")"),
+        Some(Type::Str(_)) | Some(Type::SliceRef(_)) if !indirect_return => write!(out, ")"),
         _ => {}
     }
     if indirect_return {
@@ -694,7 +694,7 @@ fn write_rust_function_shim_impl(
                 out.builtin.rust_str_new_unchecked = true;
                 write!(out, "::rust::impl<::rust::Str>::new_unchecked(");
             }
-            Type::SliceRefU8(_) => {
+            Type::SliceRef(_) => {
                 out.builtin.rust_slice_new = true;
                 write!(out, "::rust::impl<");
                 write_type(out, ret);
@@ -722,7 +722,7 @@ fn write_rust_function_shim_impl(
                 out.builtin.rust_str_repr = true;
                 write!(out, "::rust::impl<::rust::Str>::repr(");
             }
-            Type::SliceRefU8(_) => {
+            Type::SliceRef(_) => {
                 out.builtin.rust_slice_repr = true;
                 write!(out, "::rust::impl<");
                 write_type(out, &arg.ty);
@@ -735,7 +735,7 @@ fn write_rust_function_shim_impl(
         match &arg.ty {
             Type::RustBox(_) => write!(out, ".into_raw()"),
             Type::UniquePtr(_) => write!(out, ".release()"),
-            Type::Str(_) | Type::SliceRefU8(_) => write!(out, ")"),
+            Type::Str(_) | Type::SliceRef(_) => write!(out, ")"),
             ty if ty != RustString && out.types.needs_indirect_abi(ty) => write!(out, "$.value"),
             _ => {}
         }
@@ -757,8 +757,7 @@ fn write_rust_function_shim_impl(
     write!(out, ")");
     if !indirect_return {
         if let Some(ret) = &sig.ret {
-            if let Type::RustBox(_) | Type::UniquePtr(_) | Type::Str(_) | Type::SliceRefU8(_) = ret
-            {
+            if let Type::RustBox(_) | Type::UniquePtr(_) | Type::Str(_) | Type::SliceRef(_) = ret {
                 write!(out, ")");
             }
         }
@@ -811,7 +810,7 @@ fn write_indirect_return_type_space(out: &mut OutFile, ty: &Type) {
     write_indirect_return_type(out, ty);
     match ty {
         Type::RustBox(_) | Type::UniquePtr(_) | Type::Ref(_) => {}
-        Type::Str(_) | Type::SliceRefU8(_) => write!(out, " "),
+        Type::Str(_) | Type::SliceRef(_) => write!(out, " "),
         _ => write_space_after_type(out, ty),
     }
 }
@@ -829,7 +828,7 @@ fn write_extern_return_type_space(out: &mut OutFile, ty: &Option<Type>) {
             write_type(out, &ty.inner);
             write!(out, " *");
         }
-        Some(Type::Str(_)) | Some(Type::SliceRefU8(_)) => {
+        Some(Type::Str(_)) | Some(Type::SliceRef(_)) => {
             out.builtin.ptr_len = true;
             write!(out, "::rust::repr::PtrLen ");
         }
@@ -844,7 +843,7 @@ fn write_extern_arg(out: &mut OutFile, arg: &Var) {
             write_type_space(out, &ty.inner);
             write!(out, "*");
         }
-        Type::Str(_) | Type::SliceRefU8(_) => {
+        Type::Str(_) | Type::SliceRef(_) => {
             out.builtin.ptr_len = true;
             write!(out, "::rust::repr::PtrLen ");
         }
@@ -892,7 +891,7 @@ fn write_type(out: &mut OutFile, ty: &Type) {
         Type::Str(_) => {
             write!(out, "::rust::Str");
         }
-        Type::SliceRefU8(ty) => {
+        Type::SliceRef(ty) => {
             write!(out, "::rust::Slice<");
             if ty.mutability.is_none() {
                 write!(out, "const ");
@@ -956,7 +955,7 @@ fn write_space_after_type(out: &mut OutFile, ty: &Type) {
         | Type::Str(_)
         | Type::CxxVector(_)
         | Type::RustVec(_)
-        | Type::SliceRefU8(_)
+        | Type::SliceRef(_)
         | Type::Fn(_)
         | Type::Array(_) => write!(out, " "),
         Type::Ref(_) => {}
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 9bfdecb..ccca8b5 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -330,7 +330,7 @@ fn expand_cxx_function_shim(efn: &ExternFn, types: &Types) -> TokenStream {
                 _ => quote!(#var),
             },
             Type::Str(_) => quote!(::cxx::private::RustStr::from(#var)),
-            Type::SliceRefU8(ty) => match ty.mutable {
+            Type::SliceRef(ty) => match ty.mutable {
                 false => quote!(::cxx::private::RustSliceU8::from_ref(#var)),
                 true => quote!(::cxx::private::RustSliceU8::from_mut(#var)),
             },
@@ -426,7 +426,7 @@ fn expand_cxx_function_shim(efn: &ExternFn, types: &Types) -> TokenStream {
                     _ => call,
                 },
                 Type::Str(_) => quote!(#call.as_str()),
-                Type::SliceRefU8(ty) => match ty.mutable {
+                Type::SliceRef(ty) => match ty.mutable {
                     false => quote!(#call.as_slice()),
                     true => quote!(#call.as_mut_slice()),
                 },
@@ -616,7 +616,7 @@ fn expand_rust_function_shim_impl(
                 _ => quote!(#ident),
             },
             Type::Str(_) => quote!(#ident.as_str()),
-            Type::SliceRefU8(ty) => match ty.mutable {
+            Type::SliceRef(ty) => match ty.mutable {
                 false => quote!(#ident.as_slice()),
                 true => quote!(#ident.as_mut_slice()),
             },
@@ -663,7 +663,7 @@ fn expand_rust_function_shim_impl(
             _ => None,
         },
         Type::Str(_) => Some(quote!(::cxx::private::RustStr::from)),
-        Type::SliceRefU8(ty) => match ty.mutable {
+        Type::SliceRef(ty) => match ty.mutable {
             false => Some(quote!(::cxx::private::RustSliceU8::from_ref)),
             true => Some(quote!(::cxx::private::RustSliceU8::from_mut)),
         },
@@ -1107,7 +1107,7 @@ fn expand_extern_type(ty: &Type, types: &Types, proper: bool) -> TokenStream {
             }
         }
         Type::Str(_) => quote!(::cxx::private::RustStr),
-        Type::SliceRefU8(_) => quote!(::cxx::private::RustSliceU8),
+        Type::SliceRef(_) => quote!(::cxx::private::RustSliceU8),
         _ => quote!(#ty),
     }
 }
diff --git a/syntax/check.rs b/syntax/check.rs
index 968f28b..431aeee 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -36,7 +36,7 @@ fn do_typecheck(cx: &mut Check) {
             Type::Ref(ty) => check_type_ref(cx, ty),
             Type::Array(array) => check_type_array(cx, array),
             Type::Fn(ty) => check_type_fn(cx, ty),
-            Type::Str(_) | Type::Void(_) | Type::SliceRefU8(_) => {}
+            Type::Str(_) | Type::Void(_) | Type::SliceRef(_) => {}
         }
     }
 
@@ -179,7 +179,7 @@ fn check_type_ref(cx: &mut Check, ty: &Ref) {
 
 fn check_type_array(cx: &mut Check, ty: &Array) {
     let supported = match &ty.inner {
-        Type::Str(_) | Type::SliceRefU8(_) => false,
+        Type::Str(_) | Type::SliceRef(_) => false,
         element => !is_unsized(cx, element),
     };
 
@@ -422,7 +422,7 @@ fn is_unsized(cx: &mut Check, ty: &Type) -> bool {
         | Type::UniquePtr(_)
         | Type::Ref(_)
         | Type::Str(_)
-        | Type::SliceRefU8(_) => false,
+        | Type::SliceRef(_) => false,
     }
 }
 
@@ -492,7 +492,7 @@ fn describe(cx: &mut Check, ty: &Type) -> String {
         Type::Ref(_) => "reference".to_owned(),
         Type::Str(_) => "&str".to_owned(),
         Type::CxxVector(_) => "C++ vector".to_owned(),
-        Type::SliceRefU8(ty) => match ty.mutable {
+        Type::SliceRef(ty) => match ty.mutable {
             false => "&[u8]".to_owned(),
             true => "&mut [u8]".to_owned(),
         },
diff --git a/syntax/impls.rs b/syntax/impls.rs
index 36cf3cd..4de3c29 100644
--- a/syntax/impls.rs
+++ b/syntax/impls.rs
@@ -50,7 +50,7 @@ impl Hash for Type {
             Type::RustVec(t) => t.hash(state),
             Type::CxxVector(t) => t.hash(state),
             Type::Fn(t) => t.hash(state),
-            Type::SliceRefU8(t) => t.hash(state),
+            Type::SliceRef(t) => t.hash(state),
             Type::Array(t) => t.hash(state),
             Type::Void(_) => {}
         }
@@ -70,7 +70,7 @@ impl PartialEq for Type {
             (Type::RustVec(lhs), Type::RustVec(rhs)) => lhs == rhs,
             (Type::CxxVector(lhs), Type::CxxVector(rhs)) => lhs == rhs,
             (Type::Fn(lhs), Type::Fn(rhs)) => lhs == rhs,
-            (Type::SliceRefU8(lhs), Type::SliceRefU8(rhs)) => lhs == rhs,
+            (Type::SliceRef(lhs), Type::SliceRef(rhs)) => lhs == rhs,
             (Type::Void(_), Type::Void(_)) => true,
             (_, _) => false,
         }
diff --git a/syntax/improper.rs b/syntax/improper.rs
index 95cf4af..e0e5154 100644
--- a/syntax/improper.rs
+++ b/syntax/improper.rs
@@ -27,7 +27,7 @@ impl<'a> Types<'a> {
             | Type::Str(_)
             | Type::Fn(_)
             | Type::Void(_)
-            | Type::SliceRefU8(_) => Definite(true),
+            | Type::SliceRef(_) => Definite(true),
             Type::UniquePtr(_) | Type::CxxVector(_) => Definite(false),
             Type::Ref(ty) => self.determine_improper_ctype(&ty.inner),
             Type::Array(ty) => self.determine_improper_ctype(&ty.inner),
diff --git a/syntax/mod.rs b/syntax/mod.rs
index c3c24ff..69b77bc 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -164,7 +164,7 @@ pub enum Type {
     CxxVector(Box<Ty1>),
     Fn(Box<Signature>),
     Void(Span),
-    SliceRefU8(Box<SliceRef>),
+    SliceRef(Box<SliceRef>),
     Array(Box<Array>),
 }
 
diff --git a/syntax/parse.rs b/syntax/parse.rs
index 71da158..25b17fd 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -651,7 +651,7 @@ fn parse_type_reference(ty: &TypeReference) -> Result<Type> {
     if let RustType::Slice(slice) = ty.elem.as_ref() {
         let inner = parse_type(&slice.elem)?;
         return match &inner {
-            Type::Ident(ident) if ident.rust == U8 => Ok(Type::SliceRefU8(Box::new(SliceRef {
+            Type::Ident(ident) if ident.rust == U8 => Ok(Type::SliceRef(Box::new(SliceRef {
                 ampersand: ty.and_token,
                 lifetime: ty.lifetime.clone(),
                 mutable: ty.mutability.is_some(),
diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index 7b64a2d..8ce7ed9 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -24,7 +24,7 @@ impl ToTokens for Type {
             Type::Array(a) => a.to_tokens(tokens),
             Type::Fn(f) => f.to_tokens(tokens),
             Type::Void(span) => tokens.extend(quote_spanned!(*span=> ())),
-            Type::SliceRefU8(r) => r.to_tokens(tokens),
+            Type::SliceRef(r) => r.to_tokens(tokens),
         }
     }
 }
diff --git a/syntax/types.rs b/syntax/types.rs
index 746370c..8983273 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -42,7 +42,7 @@ impl<'a> Types<'a> {
         fn visit<'a>(all: &mut Set<&'a Type>, ty: &'a Type) {
             all.insert(ty);
             match ty {
-                Type::Ident(_) | Type::Str(_) | Type::Void(_) | Type::SliceRefU8(_) => {}
+                Type::Ident(_) | Type::Str(_) | Type::Void(_) | Type::SliceRef(_) => {}
                 Type::RustBox(ty)
                 | Type::UniquePtr(ty)
                 | Type::CxxVector(ty)

